//ESP8266WebServerSparkfunWiSht15
//TKB notes- WORKED.. and played nicely with router DHCP!
//More heavily knobbled Sparkfun... to keep pin 12 avail... and moved to a static IP
//Plus reading, reporting SHT15, also derived from Sparkfun sources.
//eSet saw as "ESP_E23D82"
//From Sparkfun, 1 Sep 2018
//https://learn.sparkfun.com/tutorials/esp8266-thing-development-board-hookup-guide/example-sketch-web-server

#include <ESP8266WiFi.h>
//#include <ESP8266mDNS.h>

const String vers="2Sept18";

//Begin large block kludged in from other Sparkfun demo...

/*ORIGINALLY: SHT15 Example

Joel Bartlett @ SparkFun Electronics
16 Sept 2015
Modified by TKB, 1 Sep 2018, to become...
   SHT15_on_ESP8266_Thing_Dev_Brd

https://github.com/sparkfun/SparkFun_ISL29125_Breakout_Arduino_Library

This example shows how to get the temperature in F or C and humidity
Developed/Tested with:
SparkFun RedBoard
Arduino IDE 1.6.5


TKB CONNECTIONS TO Sparkun ESP8266 Thing Dev Board...

(breakout)  (ESP8266)
GND           GDN
Vcc           3v3
DATA          (D)12
SCK           (D)13


Requires:
SHT1X Arduino Library
https://github.com/sparkfun/SHT15_Breakout/

This code is beerware.
Distributed as-is; no warranty is given.
******************************************************************************/
#include <SHT1X.h>

//variables for storing values
float tempC = 0;
float tempF = 0;
float humidity = 0;

SHT1x sht15(12,13);//Data, SCK for TKB version on ESP8622 Thing Dev Board

//END large block kludged in

//////////////////////
// WiFi Definitions ** MUST BE TWEAKED FOR YOUR LOCATION ** //
//////////////////////
const char WiFiSSID[] = "aug06bah_EXT";//If changed, change Welcome message
const char WiFiPSK[] = "d557909e76";

/////////////////////
// Pin Definitions //
/////////////////////
const int LED_PIN = 5; // Thing's onboard, green LED (TKB note: Blue on some (old) Thing Dev Boards)
const int ANALOG_PIN = A0; // The only analog pin on the Thing
//TKB Remmed out const int DIGITAL_PIN = 12; // Digital pin to be read

WiFiServer server(80);

long liLoopCount=0;
unsigned long liMillisNow;
unsigned long liMillisPrev;

void setup() 
{
  initHardware();
  connectWiFi();
  server.begin();
  //setupMDNS();
  Serial.begin(9600); // Open serial connection to report
  delay(400);
  Serial.println();
  Serial.println("Welcome.. TKB Chimera of two Sparkfun demos");
  Serial.println("(Bad) name, 2 Sept 18: ESP8266WebServerSparkfunWiSht15");
  Serial.println("Version "+vers);
  Serial.println("Puts webserver reporting SHT15 tture's and humidity on LAN");
  Serial.println("Created on pc2ndEllie 1 Sep 2018 after nice eve with ML and D");
  Serial.println();
  Serial.println("Configured to connect to RR extender");
  Serial.println();
  readSensor();//establish inital values.
  liMillisPrev=millis();
  liMillisNow=liMillisPrev;
}

void loop() 
{
  // Check if a client has connected
  WiFiClient client = server.available();
  if (!client) {
   //New material added to webserver demo... if no client wants service,
   //we can Do Things now....
   if (boDoNewRead())
     {
       liLoopCount=liLoopCount+1;
       readSensor();
     }
     return;
  }

  // Read the first line of the request
  String req = client.readStringUntil('\r');
  Serial.println(req);
  client.flush();

  // Match the request
  int val = -1; // We'll use 'val' to keep track of both the
                // request type (read/set) and value if set.
  if (req.indexOf("/led/0") != -1)
    val = 1; // Will write LED high
  else if (req.indexOf("/led/1") != -1)
    val = 0; // Will write LED low
  else if (req.indexOf("/read") != -1)
    val = -2; // Will print pin reads
  // Otherwise request will be invalid. We'll say as much in HTML

  // Set GPIO5 according to the request
  if (val >= 0)
    digitalWrite(LED_PIN, val);

  client.flush();

  // Prepare the response. Start with the common header:
  String s = "HTTP/1.1 200 OK\r\n";
  s += "Content-Type: text/html\r\n\r\n";
  s += "<!DOCTYPE HTML>\r\n<html>\r\n";

  //Block that always appears. (Added to Sparkfun demo by TKB)
  s += "<br>";
  s += "ESP8266 environmental monitor of 1 Sept 18, pc2ndEllie<br>";
  s += "(Bad) name, 2 Sept 18: ESP8266WebServerSparkfunWiSht15<br><br>";
  s += "Version: "+vers+"<br>";
  s += "(On pc2ndEllie)<br><br>";
  s += String(liMillisNow);
  s +=" ms since 8266 booteed.<br>";
  s +="<br>TturC=";
  s += String(tempC);
  s +="<br>Humid=";
  s += String(humidity);
  s +="<br><br>";
  //End of TKB "always appears" block
  
 // If we're setting the LED, print out a message saying we did
  if (val >= 0)
  {
    s += "LED is now ";
    s += (val)?"off":"on";
  }
  else if (val == -2)
  { // If we're reading pins, print out those values:
    s += "Analog Pin = ";
    s += String(analogRead(ANALOG_PIN));
    s += "<br>"; // Go to the next line.
//    s += "Digital Pin 12 = (disabled this feature)";
//TKB Remmed out    s += String(digitalRead(DIGITAL_PIN));
  }
  else
  {
    s += "Invalid Request.<br> Try /led/1, /led/0, or /read.";
  }
  s += "</html>\n";

  // Send the response to the client
  client.print(s);
  delay(1);
  Serial.println("Client disonnected");

  // The client will actually be disconnected 
  // when the function returns and 'client' object is detroyed
}

void connectWiFi()
{
  byte ledStatus = LOW;
  Serial.println();
  Serial.println("Connecting to: " + String(WiFiSSID));
  // Set WiFi mode to station (as opposed to AP or AP_STA)
  WiFi.mode(WIFI_STA);

  // WiFI.begin([ssid], [passkey]) initiates a WiFI connection
  // to the stated [ssid], using the [passkey] as a WPA, WPA2,
  // or WEP passphrase.
  WiFi.begin(WiFiSSID, WiFiPSK);


//TKB block added...
//begin block from https://forum.arduino.cc/index.php?topic=460595.0
//which allows static IP to be assigned, if it is right!
//YES: It goes AFTER the WiFi.begin

  IPAddress ip(192,168,0,218);//Needs tweaking for your requirement   
  IPAddress gateway(192,168,0,1);//Needs tweaking for your environment   
  IPAddress subnet(255,255,255,0);//"The usual"... but you may need to tweak   
  WiFi.config(ip, gateway, subnet);

//end block from forum

  // Use the WiFi.status() function to check if the ESP8266
  // is connected to a WiFi network.
  while (WiFi.status() != WL_CONNECTED)
  {
    // Blink the LED
    digitalWrite(LED_PIN, ledStatus); // Write LED high/low
    ledStatus = (ledStatus == HIGH) ? LOW : HIGH;

    // Delays allow the ESP8266 to perform critical tasks
    // defined outside of the sketch. These tasks include
    // setting up, and maintaining, a WiFi connection.
    delay(100);
    // Potentially infinite loops are generally dangerous.
    // Add delays -- allowing the processor to perform other
    // tasks -- wherever possible.
  }
  Serial.println("WiFi connected");  
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
}

/*Taken out becaus eusing static ip
void setupMDNS()
{
  // Call MDNS.begin(<domain>) to set up mDNS to point to
  // "<domain>.local"
  if (!MDNS.begin("thing")) 
  {
    Serial.println("Error setting up MDNS responder!");
    while(1) { 
      delay(1000);
    }
  }
  Serial.println("mDNS responder started");

}
*/

void initHardware()
{
  Serial.begin(9600);
//TKB Remmed out  pinMode(DIGITAL_PIN, INPUT_PULLUP);
  pinMode(LED_PIN, OUTPUT);
  digitalWrite(LED_PIN, HIGH);
  // Don't need to set ANALOG_PIN as input, 
  // that's all it can be.
}

void printOut()
{
  Serial.print(" Temp = ");
 // Serial.print(tempF);
 // Serial.print("F, ");
  Serial.print(tempC);
  Serial.print("C");
  Serial.print(" / Humidity = ");
  Serial.print(humidity);
  Serial.println("%");
}

void readSensor()
{
  // Read values from the sensor
  tempC = sht15.readTemperatureC();
 // tempF = sht15.readTemperatureF();
  humidity = sht15.readHumidity();
}//readSensor()

bool boDoNewRead()
{
 liMillisNow=millis();
 if ((liMillisNow-liMillisPrev>5000)||
      (liMillisNow<liMillisPrev) )//(Rolled over)
    {
      liMillisPrev=liMillisNow;
      printOut();
      return true;
    }//no ; here.. else...
    {
      return false;
    }   
}//boDoRead


